=== debian/changelog ===
mediastreamer2 (1:5.3.105+dfsg-5build2) resolute; urgency=medium

  * Rebuild against latest libvpx

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 02 Nov 2025 11:17:23 -0500

mediastreamer2 (1:5.3.105+dfsg-5build1) questing; urgency=medium

  * No-change rebuild against Qt 5.15.17.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sun, 13 Jul 2025 10:57:18 +0300

mediastreamer2 (1:5.3.105+dfsg-5) unstable; urgency=medium

  * Team upload
  * Only depend on srtp2 for arch-any build
  * Extend the build profile patch

 -- Bastian Germann <bage@debian.org>  Thu, 27 Feb 2025 11:33:18 +0100

mediastreamer2 (1:5.3.105+dfsg-4) unstable; urgency=medium

  * Team upload
  * Fix build-all

 -- Bastian Germann <bage@debian.org>  Wed, 26 Feb 2025 23:11:35 +0100

mediastreamer2 (1:5.3.105+dfsg-3) unstable; urgency=medium

  * Team upload
  * Add directory referenced in Mediastreamer2Config.cmake

 -- Bastian Germann <bage@debian.org>  Wed, 26 Feb 2025 22:15:39 +0100

mediastreamer2 (1:5.3.105+dfsg-2) unstable; urgency=medium

  * Team upload
  * Disable NEON on ARM
  * Prevent unknown pragma and unused variable errors

 -- Bastian Germann <bage@debian.org>  Wed, 26 Feb 2025 21:34:40 +0100

mediastreamer2 (1:5.3.105+dfsg-1) unstable; urgency=medium

  [ Victor Seva ]
  * Add myself to Uploaders. Remove Tzafrir. wrap-and-sort -sat
  * debian/gbp.conf: switch to DEP-14 layout
  * New upstream version 5.3.105+dfsg
  * Trim trailing whitespace.
  * Refer to common license file for Apache-2.0.
  * Set upstream metadata fields: Repository-Browse.
  * Remove unused license definitions for LGPL-2.1+.
  * Remove field Section on binary package
    libmediastreamer-data that duplicates source.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.
  * debian/gbp.conf: filter tester dir
  * rework patches
  * debian/rules: remove features not supported anymore
  * shared lib is now libmediastreamer2
  * pkg-config => pkgconf
  * debian/copyright: remove files no longer in the repo
  * Set upstream metadata fields: Repository.
  * debian/control: fix short description too long
  * debian/copyright: add myself in debian/*

  [ Dennis Filder ]
  * Advance linphone stack dependencies
  * Bump SO version due to ABI break
  * Use DEB_HOST_GNU_TYPE instead of DEB_HOST_MULTIARCH in CMake build paths
  * Update d/rules for the new soname; add early sanity check
  * Add debian/shlibs.local for tighter version linkage to bcmatroska2
  * Add another shlibs.local entry for libortp
  * Add shlibs.local entry for libbzrtp

 -- Victor Seva <vseva@debian.org>  Sun, 23 Feb 2025 00:13:24 +0100

mediastreamer2 (1:5.2.0+dfsg-4) unstable; urgency=medium

  * Team upload. (Closes: #1068917)
  * d/copyright: Use correct case for public-domain.

 -- Bastian Germann <bage@debian.org>  Sat, 13 Apr 2024 11:28:49 +0000

mediastreamer2 (1:5.2.0+dfsg-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1064170

 -- Steve Langasek <vorlon@debian.org>  Fri, 05 Apr 2024 23:48:00 +0000
