=== debian/control ===
Source: mediastreamer2
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders:
 Kilian Krause <kilian@debian.org>,
 Victor Seva <vseva@debian.org>,
 Felix Lechner <felix.lechner@gmail.com>,
 Bernhard Schmidt <berni@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libortp-dev (>= 1:5.3.104~),
Build-Depends-Indep:
 doxygen <!nodoc>,
 graphviz <!nodoc>,
Build-Depends-Arch:
 libasound2-dev [linux-any],
 libavcodec-dev (>= 6:10~),
 libavutil-dev (>= 6:10~),
 libbcg729-dev (>= 1.1.1~),
 libbcmatroska2-dev (>= 5.3.101~),
 libbctoolbox-dev (>= 5.3.101~),
 libbzrtp-dev (>= 5.3.104~),
 libgles-dev,
 libglew-dev,
 libgsm1-dev,
 libmbedtls-dev,
 libopus-dev,
 libpcap-dev,
 libpulse-dev,
 libspandsp-dev,
 libspeex-dev,
 libspeexdsp-dev,
 libsqlite3-dev,
 libsrtp2-dev [!hurd-any !sparc],
 libswscale-dev (>= 6:10~),
 libtheora-dev,
 libturbojpeg0-dev,
 libupnp-dev,
 libv4l-dev [linux-any],
 libvpx-dev,
 libx11-dev,
 libxext-dev,
 libxml2-dev,
 libxv-dev,
 libzxing-dev,
 mesa-common-dev,
 pkgconf,
 qtbase5-dev,
 qtdeclarative5-dev,
 xxd,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Section: libs
Homepage: https://www.linphone.org/technical-corner/mediastreamer2/overview
Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/mediastreamer2.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/mediastreamer2
Description: Multimedia streaming engine for telephony

Package: libmediastreamer2-14
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libmediastreamer-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 mediastreamer2-plugin-msqogl,
 mediastreamer2-plugin-opencore-amr,
 mediastreamer2-plugin-openh264,
 mediastreamer2-plugin-webrtc,
 mediastreamer2-plugin-x264,
Suggests:
 mediastreamer2-plugin-codec2,
Description: Voice and video streaming engine for telephony (base)
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains the base library.

Package: libmediastreamer-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libbctoolbox-dev,
 libmediastreamer2-14 (= ${binary:Version}),
# the .pc file mentions these 2, so a Depends: is needed
# also the headers reference files from these 2
 libortp-dev,
 ${misc:Depends},
Description: Development files for the mediastreamer2 library
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains the development files for the development library.

Package: libmediastreamer-tools
Architecture: any
Multi-Arch: no
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Voice and video streaming engine for telephony (programs)
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains some programs using the library.

Package: libmediastreamer-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Voice and video streaming engine for telephony (data files)
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains architecture-independent data files.

Package: libmediastreamer-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends:
 ${misc:Depends},
Description: Voice and video streaming engine for telephony (documentation)
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains the developer documentation.

Package: mediastreamer2-plugin-msqogl
Conflicts:
 libmediastreamer12,
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Voice and video streaming engine for telephony (OpenGL)
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains a plugin needed for OpenGL-accelerated video
 telephony support.
